题目来源:
https://leetcode-cn.com/problems/two-sum/comments/
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
我的做法:
暴力搜索法:
class Solution:
def twoSum(self, nums, target) :
c = []
for i in range(len(nums)):
for j in range(i+1,len(nums)):
if nums[i] +nums[j] == target:
c.append(i)
c.append(j)
return c
时间复杂度、空间复杂度都太高,效果不好。
评论区做法:
法一:首尾递进查找做的,需要一次排序,时间复杂度是 O(nlogn):
class Solution:
def twoSum(self, nums, target):
"""
:type nums: List[int]
:type target: int
:rtype: List[int]
"""
sorted_id = sorted(range(len(nums)), key=lambda k: nums[k])
head = 0
tail = len(nums) - 1
sum_result = nums[sorted_id[head]] + nums[sorted_id[tail]]
while sum_result != target:
if sum_result > target:
tail -= 1
elif sum_result < target:
head += 1
sum_result = nums[sorted_id[head]] + nums[sorted_id[tail]]
return [sorted_id[head], sorted_id[tail]]
时间复杂度更好,空间复杂度下降
法二:字典做,时间复杂度是 O(n):
class Solution:
def twoSum(self, nums, target):
"""
:type nums: List[int]
:type target: int
:rtype: List[int]
"""
hashmap = {}
for index, num in enumerate(nums):
another_num = target - num
if another_num in hashmap:
return [hashmap[another_num], index]
hashmap[num] = index
return None
时间复杂度更好,空间复杂度下降。